# collibra-catalog
The Catalog API offers functionality related to the catalog product.<br/>It is mainly focused on facilitating the ingestion of information into Catalog. The API enables users to more easily connect Catalog to sources that are not necessarily natively supported in the product.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import collibra_catalog
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import collibra_catalog
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import collibra_catalog
from collibra_catalog.rest import ApiException
from pprint import pprint


# Defining host is optional and default to http://localhost/rest/catalog/1.0
configuration.host = "http://localhost/rest/catalog/1.0"
# Enter a context with an instance of the API client
with collibra_catalog.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = collibra_catalog.JDBCSchemaIngestionApi(api_client)
    add_schema_from_jdbc_request = collibra_catalog.AddSchemaFromJdbcRequest() # AddSchemaFromJdbcRequest |  (optional)

    try:
        # Create a JDBC schema ingestion
        api_response = api_instance.add_schema_from_jdbc(add_schema_from_jdbc_request=add_schema_from_jdbc_request)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling JDBCSchemaIngestionApi->add_schema_from_jdbc: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/rest/catalog/1.0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*JDBCSchemaIngestionApi* | [**add_schema_from_jdbc**](docs/JDBCSchemaIngestionApi.md#add_schema_from_jdbc) | **POST** /schemas/jdbc | Create a JDBC schema ingestion
*JDBCSchemaIngestionApi* | [**refresh_jdbc_schema**](docs/JDBCSchemaIngestionApi.md#refresh_jdbc_schema) | **POST** /schemas/jdbc/{assetId} | Refresh an existing JDBC schema ingestion
*JobServerInstanceConfigurationApi* | [**get_available_job_server_instances**](docs/JobServerInstanceConfigurationApi.md#get_available_job_server_instances) | **GET** /configuration/jobServerInstance | Retrieve existing JobServer instance configurations
*MarketplaceAccountingApi* | [**get_accounting_data**](docs/MarketplaceAccountingApi.md#get_accounting_data) | **GET** /schemas/marketplace/accounting | Fetches Collibra jdbc drivers usage statistics.
*ProfilingApi* | [**update_columns_profiling_data**](docs/ProfilingApi.md#update_columns_profiling_data) | **PATCH** /profiling/columns | Updates column profiles.
*S3Api* | [**add_crawler**](docs/S3Api.md#add_crawler) | **POST** /filesystem/s3/{assetId}/crawlers | Adds a new crawler.
*S3Api* | [**add_schedule**](docs/S3Api.md#add_schedule) | **POST** /filesystem/s3/{assetId}/schedule | Adds a schedule for S3 File System synchronization.
*S3Api* | [**attach_capability**](docs/S3Api.md#attach_capability) | **PUT** /filesystem/s3/{assetId}/capability | Attach capability to S3 filesystem
*S3Api* | [**cancel**](docs/S3Api.md#cancel) | **DELETE** /filesystem/s3/{assetId}/synchronize | Schedule canceling of s3 synchronization
*S3Api* | [**delete_crawler**](docs/S3Api.md#delete_crawler) | **DELETE** /filesystem/s3/{assetId}/crawlers | Deletes a crawler.
*S3Api* | [**delete_schedule**](docs/S3Api.md#delete_schedule) | **DELETE** /filesystem/s3/{assetId}/schedule | Deletes a schedule for S3 File System synchronization.
*S3Api* | [**detach_capability**](docs/S3Api.md#detach_capability) | **DELETE** /filesystem/s3/{assetId}/capability | Detach capability from S3 filesystem
*S3Api* | [**get_attached_capability_id**](docs/S3Api.md#get_attached_capability_id) | **GET** /filesystem/s3/{assetId}/capability | Get attached capabilities for S3 filesystem
*S3Api* | [**get_crawlers**](docs/S3Api.md#get_crawlers) | **GET** /filesystem/s3/{assetId}/crawlers | Gets defined crawlers.
*S3Api* | [**get_schedule**](docs/S3Api.md#get_schedule) | **GET** /filesystem/s3/{assetId}/schedule | Gets a schedule for S3 File System synchronization.
*S3Api* | [**synchronize_s3_file_system**](docs/S3Api.md#synchronize_s3_file_system) | **POST** /filesystem/s3/{assetId}/synchronize | Asynchronously synchronizes an S3 File System.
*S3Api* | [**update_crawler**](docs/S3Api.md#update_crawler) | **PUT** /filesystem/s3/{assetId}/crawlers | Updates a crawler.
*S3Api* | [**update_schedule**](docs/S3Api.md#update_schedule) | **PUT** /filesystem/s3/{assetId}/schedule | Updates a schedule for S3 File System synchronization.


## Documentation For Models

 - [AddCrawlerRequest](docs/AddCrawlerRequest.md)
 - [AddS3ScheduleRequest](docs/AddS3ScheduleRequest.md)
 - [AddSchemaFromJdbcRequest](docs/AddSchemaFromJdbcRequest.md)
 - [AssetIdentifier](docs/AssetIdentifier.md)
 - [CategoricalMetadata](docs/CategoricalMetadata.md)
 - [ChangeS3ScheduleRequest](docs/ChangeS3ScheduleRequest.md)
 - [ColumnProfile](docs/ColumnProfile.md)
 - [Counts](docs/Counts.md)
 - [Crawler](docs/Crawler.md)
 - [CrawlerIncludePath](docs/CrawlerIncludePath.md)
 - [CrawlerIncludePathRequest](docs/CrawlerIncludePathRequest.md)
 - [DataProfilingRequest](docs/DataProfilingRequest.md)
 - [DataProfilingResponse](docs/DataProfilingResponse.md)
 - [DatabaseMetadata](docs/DatabaseMetadata.md)
 - [Distributions](docs/Distributions.md)
 - [HistogramBin](docs/HistogramBin.md)
 - [Job](docs/Job.md)
 - [JobServerInstance](docs/JobServerInstance.md)
 - [JobServerInstanceResponse](docs/JobServerInstanceResponse.md)
 - [PagedResponseJobServerInstance](docs/PagedResponseJobServerInstance.md)
 - [Point](docs/Point.md)
 - [Quantiles](docs/Quantiles.md)
 - [RefreshJdbcSchemaRequest](docs/RefreshJdbcSchemaRequest.md)
 - [RemoveCrawlerRequest](docs/RemoveCrawlerRequest.md)
 - [S3Schedule](docs/S3Schedule.md)
 - [Samples](docs/Samples.md)
 - [Statistics](docs/Statistics.md)
 - [UpdateCrawlerRequest](docs/UpdateCrawlerRequest.md)


## Documentation For Authorization


## basicAuth

- **Type**: HTTP basic authentication


## Author




