# coding: utf-8

"""
    Collibra Catalog API

    The Catalog API offers functionality related to the catalog product.<br/>It is mainly focused on facilitating the ingestion of information into Catalog. The API enables users to more easily connect Catalog to sources that are not necessarily natively supported in the product.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from collibra_catalog.api_client import ApiClient
from collibra_catalog.exceptions import (
    ApiTypeError,
    ApiValueError
)


class ProfilingApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def update_columns_profiling_data(self, **kwargs):  # noqa: E501
        """Updates column profiles.  # noqa: E501

        A value is updated only if the relative property is supplied. In order to delete a value, its property must be set to null in the request.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_columns_profiling_data(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param DataProfilingRequest data_profiling_request: The column profiles to update. If a property is not set it's ignored (not updated) If a property is set to null it's deleted.  A valid assetIdentifer contains one of the following combinations: - id - assetName, domainId - communityName, assetName, domainName  Strings containing numeric value must use `.` as decimal separator. No thousands separator should be used. In scientific notation, an `E` should separate the mantissa from the exponent, with no other extra character.
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: DataProfilingResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.update_columns_profiling_data_with_http_info(**kwargs)  # noqa: E501

    def update_columns_profiling_data_with_http_info(self, **kwargs):  # noqa: E501
        """Updates column profiles.  # noqa: E501

        A value is updated only if the relative property is supplied. In order to delete a value, its property must be set to null in the request.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_columns_profiling_data_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param DataProfilingRequest data_profiling_request: The column profiles to update. If a property is not set it's ignored (not updated) If a property is set to null it's deleted.  A valid assetIdentifer contains one of the following combinations: - id - assetName, domainId - communityName, assetName, domainName  Strings containing numeric value must use `.` as decimal separator. No thousands separator should be used. In scientific notation, an `E` should separate the mantissa from the exponent, with no other extra character.
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(DataProfilingResponse, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['data_profiling_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_columns_profiling_data" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data_profiling_request' in local_var_params:
            body_params = local_var_params['data_profiling_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/profiling/columns', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DataProfilingResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
